openapi: "3.0.0"
info:
  description: "Allow management of accounts. The consumer of this api must always send a valid OAuth2 bearer token in the Authorization header."
  version: "1.0.0"
  title: "Accounts Service"
  contact:
    email: "williamyounang@yahoo.fr"
servers:
  - url: http://localhost:3001/accounts-service
    description: Dev
  - url: http://accounts-service/accounts-service
    description: Docker

tags:
  - name: "Authorization"
    description: "Check if user is authorized based on his bearer token"

paths:
  /authorization:
    post:
      security:
        - bearerAuth:
            - ""
      summary: "check if the token is valid and has at least one of roles specified in the body request"
      tags:
        - Authorization
      operationId: "checkUserRoles"
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/AuthorizationRequest"
      responses:
        '200':
          description: |
            authorization response provided when the token is valid and has at least one of roles specified in the body request.</br>
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/AuthorizationResponse"
        '400':
          $ref: "#/components/responses/BadRequest"
        '401':
          $ref: "#/components/responses/UnauthorizedError"
        '403':
          $ref: "#/components/responses/AccessDenied"
        '500':
          $ref: "#/components/responses/InternalServerError"
components:
  securitySchemes:
    bearerAuth:            # arbitrary name for the security scheme
      type: http
      scheme: bearer
      bearerFormat: xxxxx.yyyyy.zzzzz
  responses:
    NotFound:
      description: Not found. The requested resource did not exist
    UnauthorizedError:
      description: Access token is missing or invalid
    BadRequest:
      description: Bad request. The request was malformed
    Conflict:
      description: The request could not be completed due to a conflict with the current state of the target resource.
    UnauthorizedAccess:
      description: Unauthorized access error
    AccessDenied:
      description: Access Denied
    InternalServerError:
      description: Internal server error
  schemas:
    AuthorizationRequest:
      properties:
        roles:
          type: array
          items:
            type: string
          description: 'the roles should match with those extracted from bearer token'
          example: ['READ_PATIENT', 'DELETE_PATIENT']
      required:
        - roles
    AuthorizationResponse:
      properties:
        userName:
          type: string
          example: myUserName
          description: 'it is not mandatory, but in case it is present, should be unique among all patients'
        firstName:
          type: string
          example: Andrea
        lastName:
          type: string
          example: Rossi
        fullName:
          type: string
          example: 'Rossi Andrea'
        email:
          type: string
          example: test@email.com
        emailIsVerified:
          type: boolean
          example: true
        roles:
          type: array
          items:
            type: string
          description: 'the roles available in bearer token'
          example: ['CREATE_PATIENT']